Vigee = LibStub("AceAddon-3.0"):NewAddon("Vigee", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Vigee")

local debugv = 0
local curTarget
local curTimeLeft 


local options = {
    name = "Vigee",
    handler = Vigee,
    type = "group",
    args = {
        lockedFrame = {
            type = "toggle",
            name = L["Locked"],
            desc = "TOpt1",
            get = "LockedFrame",
            set = "ToggleLockedFrame",
        },
        showInChat = {
            type = "toggle",
            name = L["Report to Party/Raid"],
            desc = "TOpt2",
            get = "IsShowInChat",
            set = "ToggleShowInChat",
        },
        showOnScreen = {
            type = "toggle",
            name = L["Announce Warning"],
            desc = "TOpt3",
            get = "IsShowOnScreen",
            set = "ToggleShowOnScreen",
        },
    },
}

local defaults = {
    profile =  {
        lockedFrame = false,
        showInChat = false,
        showOnScreen = true,
    },
}

function Vigee:OnInitialize()
    -- Called when the addon is loaded
    if (debugv) then self:Print("OnInitialize") end
    self.db = LibStub("AceDB-3.0"):New("VigeeDB", defaults, "Default")
	Vigee.init()
    LibStub("AceConfig-3.0"):RegisterOptionsTable("Vigee", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Vigee", "Vigee")
    self:RegisterChatCommand("vigee", "ChatCommand")
    self:RegisterChatCommand("Vigee", "ChatCommand")
end

function Vigee:OnEnable()
    -- Called when the addon is enabled
	if (debugv) then self:Print("OnEnable") end
    --self:RegisterEvent("ZONE_CHANGED")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "EventParse")
	-- added

	--
end

Vigee.EventParse = function(self, _, time, event, sGUID, sName, sFlags, dGUID, dName, dFlags, ...)
    --if (debugv) then self:Print("EventParse" .. event) end
	if (event=="SPELL_CAST_SUCCESS") then
		local spellId, spellName, spellSchool = select(1, ...)
		--self:Print(spellName)
  		if (spellName==L["Vigilance"]) then
     		if (sName==UnitName("player")) then
			  curTarget = dName
			  Vigee.starttimer()
    		end
    	end
    end
end

function Vigee:ZONE_CHANGED()
    if (debugv) then self:Print("ZONE_CHANGED") end
    if GetBindLocation() == GetSubZoneText() then
        if self.db.profile.showInChat then
            --self:Print(self.db.profile.message)
        end

        if self.db.profile.showOnScreen then
            UIErrorsFrame:AddMessage(self.db.profile.message, 1.0, 1.0, 1.0, 5.0)
        end
    end
end

function Vigee:ChatCommand(input)
    if (debugv) then self:Print("ChatCommand") end
    if not input or input:trim() == "" then
        --InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(Vigee, "vigee", "Vigee", input)
    end
end

function Vigee:LockedFrame(info)
    return self.db.profile.lockedFrame
end

function Vigee:ToggleLockedFrame(info, value)
    self.db.profile.lockedFrame = value
end

function Vigee:IsShowInChat(info)
    return self.db.profile.showInChat
end

function Vigee:ToggleShowInChat(info, value)
    self.db.profile.showInChat = value
end

function Vigee:IsShowOnScreen(info)
    return self.db.profile.showOnScreen
end

function Vigee:ToggleShowOnScreen(info, value)
    self.db.profile.showOnScreen = value
end

--- aaand added

function Vigee:init()
    --if (debugv) then self:Print("init") end
	if not VigeeDB then VigeeDB = {} end
	if not VigeeDB.left then VigeeDB.left = 200 end
	if not VigeeDB.top then VigeeDB.top = 500 end
	if not VigeeDB.locked then VigeeDB.locked = 0 end
	if not VigeeDB.width then VigeeDB.width = 200 end
	if not VigeeDB.height then VigeeDB.height = 16 end
	
	Vigee.lastdisplayupdate = 0

	Vigee.statusbar = CreateFrame("StatusBar","VigeeTimerStatusBar",UIParent,"TextStatusBar")
	Vigee.statusbar:SetWidth(VigeeDB.width)
	Vigee.statusbar:SetHeight(VigeeDB.height)
	Vigee.statusbar:EnableMouse(1-VigeeDB.locked)
	Vigee.statusbar:SetMovable(true)
	Vigee.statusbar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	Vigee.statusbar:SetStatusBarColor(1.0,0.0,0.0)
	Vigee.statusbar:SetScript("OnMouseDown",function() Vigee.statusbar:StartMoving() end)
	Vigee.statusbar:SetScript("OnMouseUp",function() Vigee.statusbar:StopMovingOrSizing() VigeeDB.left = Vigee.statusbar:GetLeft() VigeeDB.top = Vigee.statusbar:GetTop() end)
	
	Vigee.statusbaricon = CreateFrame("Frame","VigeeTimerIconFrame",Vigee.statusbar)
	Vigee.statusbaricontex = Vigee.statusbaricon:CreateTexture(nil,"BORDER")
	Vigee.statusbaricontex:SetTexture("Interface\\Icons\\Ability_Warrior_Vigilance")
	Vigee.statusbaricon:SetWidth(VigeeDB.height+3)
	Vigee.statusbaricon:SetHeight(VigeeDB.height+3)
	Vigee.statusbaricon:SetPoint("RIGHT",Vigee.statusbar,"LEFT",-3,0)
	Vigee.statusbaricontex:SetAllPoints()
	
	Vigee.statusbarBorderFrame = CreateFrame("Frame","BuffCheckerOutputFrameStatusBar",Vigee.statusbar)
	Vigee.statusbarBorderFrame:SetPoint("TOPLEFT",Vigee.statusbar,"TOPLEFT",-3,3)
	Vigee.statusbarBorderFrame:SetPoint("BOTTOMRIGHT",Vigee.statusbar,"BOTTOMRIGHT",3,-3)
	Vigee.statusbarBorderFrame:SetFrameStrata("BACKGROUND")
	Vigee.statusbarBorderFrame:SetBackdrop({bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
	      edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
	      tile=1, tileSize=1,edgeSize=10,
	      insets={left=3,right=3,top=3,bottom=3}});
	Vigee.statusbarBorderFrame:SetBackdropColor(.5,.5,.5,.9)
	Vigee.statusbarBorderFrame:Show()
	

	Vigee.statusbartext = Vigee.statusbar:CreateFontString("VigeeTimerStatusBar","ARTWORK","GameFontNormal")
	Vigee.statusbartext:SetText("No Target")
	Vigee.statusbartext:SetAllPoints()
	
	Vigee.statusbar:SetPoint("TOPLEFT",UIParent,"TOPLEFT",VigeeDB.left,-VigeeDB.top)
     
	Vigee.statusbar:Show()

end

function Vigee:timertick()
    --if (debugv) then self:Print("timertick") end
--not very optimized but it gets the job done. =)
	if GetTime() > Vigee.lastdisplayupdate + .25 then
		curTimeLeft = Vigee.stoptime - GetTime()
		Vigee.statusbar:SetValue(Vigee.stoptime - GetTime())
		Vigee.lastdisplayupdate = GetTime()
	end
		
	if GetTime() > Vigee.lastupdate + 1 then
	    curTimeLeft = (curTimeLeft) - 1
		curTimeLeftmins = ceil(curTimeLeft / 60)
		Vigee.statusbartext:SetText(curTarget .. "  " .. curTimeLeftmins .. "min")
		Vigee.lastupdate = GetTime()
	end
	
	if GetTime() > Vigee.stoptime then
		Vigee.statusbar:SetAlpha(Vigee.statusbar:GetAlpha()-.1)
		--if Vigee.statusbar:GetAlpha() <= 0 then
			Vigee.statusbar:SetScript("OnUpdate",nil)
			--Vigee.statusbar:Hide()
			--Vigee.statusbar:SetAlpha(1.0)
			Vigee.statusbar:SetStatusBarColor(1.0,1.0,0.0)
		--end
	end
	
	if (Vigee.BuffExists() == false) then    
	    if GetTime () > Vigee.fromstartdelay then
	      Vigee.statusbar:SetScript("OnUpdate",nil)
		  Vigee.statusbartext:SetText(curTarget)
		  Vigee.statusbar:SetValue(Vigee.weduration)
		  Vigee.statusbar:SetStatusBarColor(1.0,0.0,0.0)
		  Vigee.AlertFade()
		end 
	end
end

function Vigee:AlertFade() 
  --Print("Vigilance set on" .. curTarget)
  if Vigee.db.profile.showOnScreen == true then
    UIErrorsFrame:AddMessage("Vigilance faded from " .. curTarget, 1.0, 0.0, 0.0, 5.0) --print to error frame
  end
end

function Vigee:AlertSet() 
  --Print("Vigilance faded from" .. curTarget)
  if Vigee.db.profile.showOnScreen == true then
    UIErrorsFrame:AddMessage("Vigilance set on" .. curTarget, 1.0, 1.0, 1.0, 5.0) --print to error frame
  end
end

function Vigee:starttimer()
    --if (debugv) then self:Print("starttimer") end
	Vigee.weduration = 1800
	Vigee.stoptime = GetTime() + Vigee.weduration
	Vigee.fromstartdelay = (Vigee.stoptime - Vigee.weduration) + 1
	Vigee.lastupdate = GetTime()
	Vigee.statusbar:SetMinMaxValues(0,Vigee.weduration)
	Vigee.statusbar:SetValue(Vigee.weduration)
	Vigee.statusbar:Show()
	Vigee.statusbar:SetStatusBarColor(0.0,1.0,0.0)	Vigee.statusbar:SetScript("OnUpdate",function() Vigee.timertick() end)
	Vigee.AlertSet()

	--Vigee.statusbartext:SetText(curTarget)
end

function Vigee:BuffExists()
  	for i = 1, 40 do
		local n = UnitBuff (curTarget,i)
		if n == L["Vigilance"] then	return true end
		if not n then return false end
	end
	return false
end
